#if defined (_MSC_VER) && (_MSC_VER >= 1020)
#pragma once
#endif

#ifndef SERVER_INSTANCE_INCLUDED__
#define SERVER_INSTANCE_INCLUDED__

#include "WASPPluginSDK\WASPDLLEntryPoints.h"

#include <string>

class CServerInstance
{
   public :

      explicit CServerInstance(
         const char *pConfigValue,
         const WaspFunctions *pWaspFunctions);

      ~CServerInstance();

      WaspConnectionUserData OnConnectionEstablished(
         const WaspConnectionHandle connectionHandle,
         const sockaddr *pAddress,
         const WaspAddressLength addressLength);

      void OnReadCompleted(
         const WaspConnectionHandle connectionHandle,
         WaspConnectionUserData connectionUserData,
         const BYTE * const pDataIn,
         const WaspDataLength dataLength);

      void OnConnectionClientClosed(
         const WaspConnectionHandle connectionHandle,
         WaspConnectionUserData connectionUserData);

      void OnConnectionReset(
         const WaspConnectionHandle connectionHandle,
         WaspConnectionUserData connectionUserData,
         const WaspLastError lastError);

      void OnConnectionClosed(
         const WaspConnectionHandle connectionHandle,
         WaspConnectionUserData connectionUserData,
         const WaspConnectionClosureReason reason);

      void OnConnectionComplete(
         const WaspConnectionHandle connectionHandle,
         WaspConnectionUserData connectionUserData);

      void OnShutdownInitiated();

   private :

      void LogMessage(
         const std::string &message);

      const std::string m_configValue;

      WaspFunctions m_waspFunctions;

      /// No copies do not implement
      CServerInstance(const CServerInstance &rhs);
      /// No copies do not implement
      CServerInstance &operator=(const CServerInstance &rhs);
};

#endif // SERVER_INSTANCE_INCLUDED__
